Index: asp3_tinet_ecnl_arm/trunk/app1_usb_watt_meter/src/main.c
===================================================================
--- asp3_tinet_ecnl_arm/trunk/app1_usb_watt_meter/src/main.c	(revision 359)
+++ asp3_tinet_ecnl_arm/trunk/app1_usb_watt_meter/src/main.c	(revision 364)
@@ -45,4 +45,5 @@
 #include <sil.h>
 #include <setjmp.h>
+#include <stdlib.h>
 #include <string.h>
 #include "syssvc/serial.h"
@@ -80,5 +81,7 @@
 
 ID ws_api_mailboxid = MAIN_DATAQUEUE;
+#ifndef NOUSE_MPF_NET_BUF
 ID ws_mempoolid = MPF_NET_BUF_256;
+#endif
 
 #if defined(IF_ETHER_BTUSB) || defined(IF_ETHER_ENBT)
@@ -114,7 +117,42 @@
 static void main_timeout();
 
+extern int ntshell_exit;
+
 int uart_read(char *buf, int cnt, void *extobj)
 {
-	return serial_rea_dat(SIO_PORTID, (char *)buf, cnt);
+	struct main_t *obj = (struct main_t *)extobj;
+	int result;
+	ER ret;
+	int timer;
+
+	obj->prev = obj->now;
+
+	/* タイマー取得 */
+	timer = main_get_timer();
+
+	/* 待ち */
+	ret = serial_trea_dat(SIO_PORTID, buf, cnt, timer);
+	if ((ret < 0) && (ret != E_OK) && (ret != E_TMOUT)) {
+		syslog(LOG_NOTICE, "tslp_tsk ret: %s %d", itron_strerror(ret), timer);
+		ntshell_exit = 1;
+		return -1;
+	}
+	result = (int)ret;
+
+	ret = get_tim(&obj->now);
+	if (ret != E_OK) {
+		syslog(LOG_NOTICE, "get_tim ret: %s", itron_strerror(ret));
+		ntshell_exit = 1;
+		return -1;
+	}
+
+			/* 時間経過 */
+	int elapse = obj->now - obj->prev;
+	main_progress(elapse);
+
+	/* タイムアウト処理 */
+	main_timeout();
+
+	return result;
 }
 
@@ -122,19 +160,4 @@
 {
 	return serial_wri_dat(SIO_PORTID, buf, cnt);
-}
-
-unsigned char ntstdio_xi(struct ntstdio_t *handle)
-{
-	char buf[1];
-	if(serial_rea_dat(SIO_PORTID, buf, 1) != 1)
-		return -EIO;
-	return buf[0];
-}
-
-void ntstdio_xo(struct ntstdio_t *handle, unsigned char c)
-{
-	char buf[1];
-	buf[0] = c;
-	serial_wri_dat(SIO_PORTID, buf, 1);
 }
 
@@ -156,5 +179,5 @@
 	main_initialize();
 
-	ntshell_init(&ntshell, uart_read, uart_write, cmd_execute, NULL);
+	ntshell_init(&ntshell, uart_read, uart_write, cmd_execute, &main_obj);
 	ntshell_set_prompt(&ntshell, "NTShell>");
 	ntshell_execute(&ntshell);
@@ -176,7 +199,12 @@
 	ER ret;
 
+#ifdef TOPPERS_OMIT_TECS
+	serial_opn_por(SIO_PORTID);
+#endif
+	serial_ctl_por(SIO_PORTID, IOCTL_FCSND | IOCTL_FCRCV);
+
 	//wolfSSL_Debugging_ON();
 
-	ntshell_task_init();
+	ntshell_task_init(uart_read, uart_write, &main_obj);
 
 	main_obj.timer = TMO_FEVR;
@@ -313,8 +341,31 @@
 }
 
+int cmd_creid(int argc, char **argv)
+{
+	if (argc != 2) {
+		printf("creid {client_id}\n");
+		return 0;
+	}
+
+	client_set_client_id(argv[1]);
+
+	return 0;
+}
+
+int cmd_secret(int argc, char **argv)
+{
+	if (argc != 2) {
+		printf("secret {client_secret}\n");
+		return 0;
+	}
+
+	client_set_client_secret(argv[1]);
+
+	return 0;
+}
+
 int cmd_logupload(int argc, char **argv)
 {
-	client_task(0);
-	return 0;
+	return client_upload_file(argc, argv);
 }
 
@@ -335,4 +386,11 @@
 	{"dnsc", "DNS client", usrcmd_dnsc },
 	{"ntpc", "NTP client", usrcmd_ntpc },
+	{"creid", "Regster device", cmd_creid},
+	{"secret", "Regster device", cmd_secret},
+	{"gdi", "get_device_id", client_get_device_id},
+	{"gat", "get_access_token", client_get_access_token},
+	{"uat", "update_access_token", client_update_access_token},
+	{"rd", "revoke device", client_revoke},
+	{"uf", "upload_file", client_upload_file},
 	{"logupload", "Upload log to server", cmd_logupload},
 	{"info", "This is a description text string for info command.", usrcmd_info},
Index: asp3_tinet_ecnl_arm/trunk/app1_usb_watt_meter/src/main.cfg
===================================================================
--- asp3_tinet_ecnl_arm/trunk/app1_usb_watt_meter/src/main.cfg	(revision 359)
+++ asp3_tinet_ecnl_arm/trunk/app1_usb_watt_meter/src/main.cfg	(revision 364)
@@ -54,5 +54,4 @@
 INCLUDE("tinet/tinet_asp.cfg");
 INCLUDE("tinet_main.cfg");
-INCLUDE("netinet/ip_igmp.cfg");
 
 /* DHCP クライアント */
